<template>
    <div class="location-widget">
        <div class="location-widget-header d-flex">
             <div class="label">
                <!-- <div class="location-widget-header-media">
                    <span class="kt-media kt-media--md kt-media--circle kt-hidden-"> 
                        <img src="/images/3.png" alt="image">
                    </span>
                </div> -->
                 <div class="location-widget-header-info ml-2">
                     <div class="title"> 
                        <span v-if="vehicule_est_connu">
                            <i class="nav-icon fas fa-user mr-2"></i> {{ location.client.nomComplet}}
                        </span>
                        <span v-else>
                            <i class="nav-icon fas fa-car mr-2"></i> {{ location.vehicule.libelle}}
                        </span>
                    </div>
                     <div class="desc"> 
                      <span class="badge bagde-secondary">RG04042020</span>  <div class="separator separator-v"></div> <strong>Statut : </strong>
                      <span v-if="location.en_cours=='En cours'"  :class="['badge badge-primary text-uppercase bg-blue']"  v-text="location.en_cours"> </span> 
                      <span v-else-if="location.en_cours=='En attente'"  :class="['badge badge-warning text-uppercase']"  v-text="location.en_cours"> </span> 
                      <span v-else :class="['badge badge-secondary text-uppercase']"  v-text="location.en_cours"> </span>    
                     </div>
                 </div>
             </div>
             <div class="toolbar">
                  <span class="money">{{ location.montant | monnaie }}</span>  <span class="monnaie ml-1">F cfa</span>
             </div>
        </div>
        <div class="location-widget-body">
              <div class="location-widget-stats">
                    <div class="location-widget-item">
                        <span class="location-widget-date">
                            <i class="fas fa-hourglass-start mr-2" style=""></i> Début de la Location
                        </span> 
                        <div class="label">
                           <span class="btn btn-label-brand btn-sm btn-bold  d-inline-block w-100">{{ location.date_dbt | toDateTime }}</span>
                        </div>
                   </div> 
                    <div class="location-widget-item ml-4">
                        <span class="location-widget-date">
                          <i class="fas fa-hourglass-end mr-2" style=""></i> Fin de la Location
                        </span> 
                        <div class="label">
                           <span class="btn btn-label-danger btn-sm btn-bold  d-inline-block w-100">{{ location.date_fin_prev | toDateTime }}</span>
                        </div>
                   </div>
                   <div class="location-widget-item ml-4 flex-fill">
                        <span class="subtitel">
                            <template v-if="dateEnAttente">
                                Progression ( <strong> 0 </strong> jour / {{entity.nbr_jour}} ->  <strong>En attente</strong>)
                            </template>
                            <template v-else-if="dateDepassee_">
                                 Progression ( <strong> {{ entity.nbr_jour-joursRestant}} </strong> jours / {{entity.nbr_jour}} ->  <strong>Completée</strong>)
                            </template>
                            <template v-else>
                                 Progression ( <strong> {{ entity.nbr_jour-joursRestant}} jours </strong> restants  / {{entity.nbr_jour}} ->  <strong>En cours</strong> )
                            </template>

                        </span>
                        <div class="location-widget-item-progress d-flex  align-items-center">
                            <div class="progress" style="height: 5px;width: 100%;">
                                <div class="progress-bar kt-bg-warning" role="progressbar" :style="{ width: progression + '%' }" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100"></div>
                            </div>
                            <span class="kt-widget__stat ">
                                                            {{ progression}}%
                            </span>
                        </div>
                    </div> 
              </div>
        </div>
        <div class="location-widget-footer">
             <div class="footer-wrapper ">
                  <div class="footer-wrapper-section">
                      <div class="footer-wrapper-section-blog">

                      </div>      
                  </div>
                  <div class="footer-wrapper-section">
                        <router-link :to="'/locations/'+location.id" type="button" class="btn btn-brand btn-sm btn-upper btn-bold mr-2"> <i class="fas fa-eye mr-2" style=""></i> Détails</router-link>
                        <button type="button" class="btn btn-brand btn-sm btn-upper btn-bold mr-2"> <i class="fas fa-ban mr-2" style=""></i> Annuler</button>
                        <button @click="prolongerEvent(location)" type="button" class="btn btn-brand btn-sm btn-upper btn-bold"> <i class="fas fa-retweet mr-2" style=""></i>Prolonger</button>
                 </div>
             </div>
        </div>

    </div>
</template>
<script>
    export default {
        props: ['entity','isSet'],       
         data() {
            return{
                vehicule_est_connu:false,
                location:{
                    date_dbt: "",
                    date_fin_prev: "",
                    client_id: "",
                    vehicule_id: "",
                    montant: "",
                    montant_ttc:"",
                    nbr_jour:"",
                    client:{},
                    vehicule:{},
                    client_est_chauffeur: "",
                    nom_chauffeur: "",
                    nom_chauffeur_2: "",
                    updated_at: "",
                    created_at: "",
                    id: "",
                }
            }
            
        },
        mounted() {
            this.location = this.entity
            this.vehicule_est_connu = this.isSet != null ? this.isSet : this.vehicule_est_connu

        },
        computed:
        {
            joursRestant()
            {
                 var jours = 0
                if(this.location.date_fin_prev=="") return jours
                if(this.dateDepassee_ || this.dateEnAttente )
                {
                    jours = 0
                }
                else
                {
                    var end = moment(this.location.date_fin_prev);
                    jours = this.entity.nbr_jour - end.diff(moment(), 'days')
                    console.log(this.entity.nbr_jour,jours)
                }
                return jours
            },
            
             dateDepassee_()
            {
                if(this.location.date_fin_prev=="") return false
                 
                var now = moment();
                var end = moment(this.location.date_fin_prev);
                return now.isAfter(end);
            },
            dateEnAttente()
            {
                if(this.location.date_dbt=="") return false
                 
                var now = moment();
                var start = moment(this.location.date_dbt);
                return now.isBefore(start);
            },
            enCours()
            {
             if(this.location.date_dbt=="") return false
                 
                var now = moment();
                var start = moment(this.location.date_dbt);
                return now.after(start) && this.dateDepassee_==false;
            },
            progression()
            {
                let percent  = 0
                 if(this.dateDepassee_ && this.joursRestant == 0)
                 {
                     percent = 100
                 }
              
                return percent
            },

        },
        methods:
        {
            prolongerEvent(location)
            {
             //on ajoute la voiture a la location
              location.vehicule = this.$parent.entity
              //on emet un event
              window.event.$emit('prolongement-event',location)
            },
            nowIsOverdue(end)
            {
                var now = moment();
                var end = moment(end);
                return now.isAfter(end);
            },
        }
    }
</script>
<style lang="scss" scoped>
 .location-widget
 {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    height: calc(100% + 20px);
        -webkit-box-shadow: 0 0 13px 0 rgba(82,63,105,.05);
    box-shadow: 0 0 13px 0 rgba(82,63,105,.05);
    background-color: #fff;
    margin-bottom: 20px;
    border-radius: 4px;
    .label 
    {
            display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
          .location-widget-header-media
          {
              margin-top: 1.5px;
          }
          .location-widget-header-info
          {
              .title
              {
                font-size: 1.3rem;
                color: #48465b;
                font-weight: 600;
              }
              .desc
              {
                padding-top: .4rem;
                color: #595d6e;
                font-weight: 500;
                display: block;
              }
          }
    }
    .toolbar
    {
        display: -webkit-box;
        display: -ms-flexbox;
        display: flex;
        -webkit-box-align: start;
        -ms-flex-align: start;
        align-items: flex-start;
    }
 }

 .location-widget-header
  {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-pack: justify;
    -ms-flex-pack: justify;
    justify-content: space-between;
    -ms-flex-wrap: wrap;
    flex-wrap: wrap;
    padding: 25px;
    padding-bottom: 0px;
    padding-top: 20px;
 }
 .location-widget-body {
    padding: 25px;
    padding-top: 0px;
    height: 100%;

 }
 .location-widget-stats {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -ms-flex-wrap: wrap;
    flex-wrap: wrap;
}
 .location-widget-body  .location-widget-stats .location-widget-item 
{
   padding-top: 1rem;
   margin-left: 5px;
   line-height: 2;
}
.location-widget-body  .location-widget-stats .location-widget-item:last-child {
    padding-left: 1rem;
}
.flex-fill {
    -webkit-box-flex: 1!important;
    -ms-flex: 1 1 auto!important;
    flex: 1 1 auto!important;
}
.location-widget-body  .location-widget-stats .location-widget-item .subtitel {
    color: #595d6e;
    font-weight: 500;
    display: block;
}
 .location-widget-body  .location-widget-stats .location-item .location-widget-date
{
    color: #595d6e;
    font-weight: 500;
    padding-bottom: 1rem;
    font-size:1.3rem;
    display: block;
}
.location-widget-footer 
{
        border-top: 1px solid #ebedf2;
        width: 100%;
}
.location-widget-footer .footer-wrapper 
    {
    padding: 15px;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-pack: justify;
    -ms-flex-pack: justify;
    justify-content: space-between;
    -ms-flex-wrap: wrap;
    flex-wrap: wrap;
    -webkit-box-align: center;
    -ms-flex-align: center;
    align-items: center;
    }

.location-widget-footer  .footer-wrapper-section 
{
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-align: center;
    -ms-flex-align: center;
    align-items: center;
}
.location-widget-footer .footer-wrapper-section-blog
 {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-align: center;
    -ms-flex-align: center;
    align-items: center;
 }
 .location-widget-footer .footer-wrapper-section-blog a
 {
    font-weight: 700;
    padding-left: .6rem;
 }
       
.kt-media.kt-media--circle 
{
    border-radius: 50%;
}

.kt-media {
    display: -webkit-inline-box;
    display: -ms-inline-flexbox;
    display: inline-flex;
    background-repeat: no-repeat;
    background-position: center center;
    background-size: cover;
    border-radius: 4px;
}
.kt-media img {
    width: 65px;
}

.kt-media.kt-media--circle img {
    border-radius: 50%;
}
.kt-media.kt-media--md img {
    width: 100%;
    max-width: 47px;
    height: 47px;
}
.btn.btn-label-danger {
    background-color: rgba(253,57,122,.1);
    color: #fd397a;
    cursor: text!important;
}
.money {
    color: #48465b;
    font-size: 25px;
    font-weight: 800;
}
.monnaie {
    font-weight: 600;
}
.separator.separator-v {
    width: 2px;
    height: 15px;
}

.separator {
    display: inline-block;
    width: 12px;
    height: 4px;
    border-radius: 2px;
    background: #e7e8ef;
    margin: 0 .2rem 0 .2rem;
}
</style>